from story.story_manager import *
from generator.gpt2.gpt2_generator import *
from story.utils import *
import time, sys, os
from playsound import playsound
from colorama import init,Fore, Back, Style
os.environ["TF_CPP_MIN_LOG_LEVEL"] = "3"

#Colorama init
init()

def splash():
    print("0) New Game\n1) Load Game\n")
    choice = get_num_options(2)

    if choice == 1:
        return "load"
    else:
        return "new"

def select_game():
    with open(YAML_FILE, 'r') as stream:
        data = yaml.safe_load(stream)

    print("Pick a setting.")
    settings = data["settings"].keys()
    for i, setting in enumerate(settings):
        print_str = str(i) + ") " + setting
        if setting == "fantasy":
            print_str += " (recommended)"

        console_print(print_str)
    console_print(str(len(settings)) + ") custom")
    choice = get_num_options(len(settings)+1)

    if choice == len(settings):

        context = ""
        console_print("\nEnter a prompt that describes who you are and the first couple sentences of where you start "
                      "out ex:\n 'You are a coomer in the cumdom of Cunny. You are hunting the evil femoid who has been " +
                      "terrorizing the cumdom. You enter the AI Dungeon searching for the femoid and see' ")
        prompt = input("Starting Prompt: ")
        return context, prompt

    setting_key = list(settings)[choice]

    print("\nPick a character")
    characters = data["settings"][setting_key]["characters"]
    for i, character in enumerate(characters):
        console_print(str(i) + ") " + character)
    character_key = list(characters)[get_num_options(len(characters))]

    name = input("\nWhat is your name? ")
    setting_description = data["settings"][setting_key]["description"]
    character = data["settings"][setting_key]["characters"][character_key]

    context = "You are " + name + ", a " + character_key + " " + setting_description + \
              "You have a " + character["item1"] + " and a " + character["item2"] + ". "
    prompt_num = np.random.randint(0, len(character["prompts"]))
    prompt = character["prompts"][prompt_num]

    return context, prompt

def instructions():
    text = "\nAI Dungeon 2 Instructions: Coomer Edition"
    text += '\n AI has limited memory. For a given session it will only keep in mind the original prompt plus 8 recent events'
    text += '\n Use detailed filler prompts to keep on track'
    text += '\n write in second person, use details and describe events, like: remove her panties before looking her in the eyes, instead of: fuck her'
    text += '\n To speak enter \'say "(thing you want to say)"\' or just "(thing you want to say)" '
    text += '\n But keep in mind say and "say" is unstable as fuck and may hang your session'
    text += '\n\nThe following commands can be entered for any action: '
    text += '\n  "revert"   Reverts the last action allowing you to pick a different sized cock.'
    text += '\n  "quit"     Quits the game and saves'
    text += '\n  "restart"  Starts a new game and saves your current one'
    text += '\n  "save"     Makes a new save of your game and gives you the save ID'
    text += '\n  "load"     Asks for a save ID and loads the game if the ID is valid'
    text += '\n  "print"    Prints a transcript of your adventure (without extra newline formatting)'
    text += '\n  "help"     Prints these instructions again'
    return text

def play_aidungeon_2():
 
    console_print(
        "\nAI Dungeon 2 will save your session, but will improve jack shit, also no one cares"
        + " But if you don't want to share your fetishes with everyone else, type 'nosaving' for any action. This will also turn off the "
        + "ability to save games.\n"
    )
 
    upload_story = True
 
    # "temperature" dictates randomness. A low temperature means that the AI is
    #  more likely to go with the word that best fits the context, a high
    #  temperature makes the AI more random and it may chose surprising less fitting words
    # original 0.4
    temp = 0.15
 
    # lower top_k is a hard limit of "how many fitting words should I consider",
    #  i.e. lowering this value also limits the AI in creativity
    # original 40
    top_k = 20
 
    console_print("\nBefore we start, would you like to change the default temperature (" + str(temp) + ") and top_k (" + str(top_k) + ") value?\n")
    choice = input("1) Lower the temp! I wanna cuddle!\n-) Press enter to skip\n>")
 
    if choice == "1":
        temp = float(input("New temperature: "))
        top_k = int(input("New top_k: "))
 
    print("\nInitializing AI Dungeon! (This might take a few minutes)\n")
    generator = GPT2Generator(60, temp, top_k, 0.9)
    story_manager = UnconstrainedStoryManager(generator)
    print("\n")

    with open('opening.txt', 'r', encoding='utf-8') as file:
        starter = file.read()
    print(starter)

    while True:
        if story_manager.story != None:
            del story_manager.story

        print("\n\n")
        splash_choice = splash()

        if splash_choice == "new":
            print("\n\n")
            context, prompt = select_game()
            console_print(instructions())
            print("\nGenerating story...")

            story_manager.start_new_story(prompt, context=context, upload_story=upload_story)

        else:
            load_ID = input("What is the ID of the saved game? ")
            result = story_manager.load_new_story(load_ID)
            print("\nLoading Game...\n")
            print(result)
        print("\n")
        console_print(str(story_manager.story))
        
        playsound("sound.wav", block=False)
        while True:
            sys.stdin.flush()
            sys.stdout.write(Fore.RED+Style.BRIGHT+"> "+Fore.YELLOW)
            action = input()
            sys.stdout.write(Style.RESET_ALL)
            if action == "restart":
                rating = input("Please rate the story quality from 1-10: ")
                rating_float = float(rating)
                story_manager.story.rating = rating_float
                break

            elif action == "quit":
                rating = input("Please rate the story quality from 1-10: ")
                rating_float = float(rating)
                story_manager.story.rating = rating_float
                exit()

            elif action == "nosaving":
                upload_story = False
                story_manager.story.upload_story = False
                console_print("Saving turned off.")

            elif action == "help":
                console_print(instructions())

            elif action == "save":
                if upload_story:
                    id = story_manager.story.save_to_storage()
                    console_print("Game saved.")
                    console_print("To load the game, type 'load' and enter the following ID: " + id)
                else:
                    console_print("Saving has been turned off. Cannot save.")

            elif action =="load":
                load_ID = input("What is the ID of the saved game?")
                result = story_manager.story.load_from_storage(load_ID)
                console_print("\nLoading Game...\n")
                console_print(result)
                
            elif len(action.split(" ")) == 2 and action.split(" ")[0] == "load":
                load_ID = action.split(" ")[1]
                result = story_manager.story.load_from_storage(load_ID)
                console_print("\nLoading Game...\n")
                console_print(result)

            elif action == "print":
                print("\nPRINTING\n")
                print(str(story_manager.story))

            elif action == "revert":

                if len(story_manager.story.actions) is 0:
                    console_print("You can't go back any farther. ")
                    continue

                story_manager.story.actions = story_manager.story.actions[:-1]
                story_manager.story.results = story_manager.story.results[:-1]
                console_print("Last action reverted. ")
                if len(story_manager.story.results) > 0:
                    console_print(story_manager.story.results[-1])
                else:
                    console_print(story_manager.story.story_start)
                continue

            else:
                if action == "":
                    action = ""
                    result = story_manager.act(action)
                    console_print(result)

                elif action[0] == '"':
                    action = "You say " + action

                else:
                    action = action.strip()
                    action = action[0].lower() + action[1:]

                    if "You" not in action[:6] and "I" not in action[:6]:
                        action = "You " + action

                    if action[-1] not in [".", "?", "!"]:
                        action = action + "."

                    action = first_to_second_person(action)

                    action = "\n> " + action + "\n"

                result = "\n" + story_manager.act(action)
                if len(story_manager.story.results) >= 2:
                    similarity = get_similarity(story_manager.story.results[-1], story_manager.story.results[-2])
                    if similarity > 0.9:
                        story_manager.story.actions = story_manager.story.actions[:-1]
                        story_manager.story.results = story_manager.story.results[:-1]
                        console_print("It's looping. Try something else or reword your action.")
                        continue

                if player_won(result):
                    console_print(result + "\n CONGRATS YOU WIN")
                    break
                elif player_died(result):
                    console_print(result)
                    console_print("YOU DIED. GAME OVER")
                    console_print("\nOptions:")
                    console_print('0) Start a new game')
                    console_print('1) "I\'m not dead yet!" (If you didn\'t actually die) ')
                    console_print('Which do you choose? ')
                    choice = get_num_options(2)
                    if choice == 0:
                        break
                    else:
                        console_print("Sorry about that...where were we?")
                        console_print(result)

                else:
                    console_print(result)
                playsound("sound.wav", block=False)

if __name__ == '__main__':
    play_aidungeon_2()
